// **************************************************************************
// File: Tree.java
// **************************************************************************
// Author: Paul Jackson
// Date: 16/11/07

package example.arith;

import java.util.ArrayList;

import java.io.StringWriter;
import java.io.PrintWriter;
import java.io.Writer;

import static example.arith.Kind.*;

public class Tree {

    public static void main(String args[]) {

        Tree a = new Tree(VAR, "a");
        Tree b = new Tree(VAR, "b");
        Tree c = new Tree(VAR, "c");
        Tree d = new Tree(PLUS, a,b);
        Tree e = new Tree(TIMES, c,d);
        System.out.println(e);
        return;
    }
    public Kind kind;
    public String id;
    public ArrayList<Tree> children;

    public Tree(Kind k, String s) {
        kind = k;
        id = s;
        children = new ArrayList<Tree>();
    }
    public Tree(Kind k, Tree ch1, Tree ch2) {
        kind = k;
        id = new String();
        children = new ArrayList<Tree>();
        children.add(ch1);
        children.add(ch2);
    }
    public String toString() {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        format(pw, 0);
        pw.flush();
        return sw.toString();
    }
    public void format(PrintWriter w, int indent) {
        
        for (int i = 0; i != indent; i++) w.print(" ");
        if (id.length() > 0) {
            w.println(kind  + "{"  + id + "}");
        } else {
            w.println(kind);
        }
        for (int j = 0; j != children.size(); j++) {
            children.get(j).format(w, indent + 2);
        }
        return;
    }
}
